Index: palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2893)
+++ palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2894)
@@ -25,4 +25,18 @@
 ! -----------------
 ! $Id$
+! Calculations of the index range of the subdomain on file which overlaps with
+! the current subdomain are already done in read_restart_data_mod,
+! lsm_read/write_restart_data was renamed to lsm_r/wrd_local, USE kinds has 
+! been removed in several routines, variable named found has been
+! introduced for checking if restart data was found, reading of restart strings
+! has been moved completely to read_restart_data_mod, lsm_rrd_local is already
+! inside the overlap loop programmed in read_restart_data_mod, the marker ***
+! end lsm *** is not necessary anymore, strings and their respective lengths 
+! are written out and read now in case of restart runs to get rid of prescribed
+! character lengths, SAVE attribute added where necessary, deallocation and 
+! allocation of some arrays have been changed to take care of different restart
+! files that can be opened (index i)
+! 
+! 2881 2018-03-13 16:24:40Z suehring
 ! Bugfix: wrong loop structure for soil moisture calculation
 ! 
@@ -85,5 +99,5 @@
 ! radiation quantities belong to surface type now
 ! surface fractions initialized
-! Rename lsm_last_actions into lsm_write_restart_data (MS)
+! Rename lsm_last_actions into lsm_wrd_subdomain (MS)
 ! 
 ! 2608 2017-11-13 14:04:26Z schwenkel
@@ -872,5 +886,5 @@
            lsm_data_output_2d, lsm_data_output_3d, lsm_energy_balance,         &
            lsm_header, lsm_init, lsm_init_arrays, lsm_parin, lsm_soil_model,   &
-           lsm_swap_timelevel, lsm_read_restart_data, lsm_write_restart_data
+           lsm_swap_timelevel, lsm_rrd_local, lsm_wrd_local
 ! !vegetat
 !-- Public parameters, constants and initial values
@@ -945,11 +959,11 @@
     END INTERFACE lsm_swap_timelevel
 
-    INTERFACE lsm_read_restart_data
-       MODULE PROCEDURE lsm_read_restart_data
-    END INTERFACE lsm_read_restart_data
-
-    INTERFACE lsm_write_restart_data
-       MODULE PROCEDURE lsm_write_restart_data
-    END INTERFACE lsm_write_restart_data
+    INTERFACE lsm_rrd_local
+       MODULE PROCEDURE lsm_rrd_local
+    END INTERFACE lsm_rrd_local
+
+    INTERFACE lsm_wrd_local
+       MODULE PROCEDURE lsm_wrd_local
+    END INTERFACE lsm_wrd_local
 
  CONTAINS
@@ -1591,5 +1605,5 @@
           message_string = 'invalid soil layer configuration found ' //        &
                            '(dz_soil_center(k) = 0.0)'
-          CALL message( 'lsm_read_restart_data', 'PA0140', 1, 2, 0, 6, 0 )
+          CALL message( 'lsm_rrd_local', 'PA0140', 1, 2, 0, 6, 0 )
        ENDIF  
     ENDDO
@@ -4301,5 +4315,5 @@
           message_string = 'For non-pavement surfaces the combination ' //     &
                            ' lai = 0.0 and c_veg = 1.0 is not allowed.'
-          CALL message( 'lsm_read_restart_data', 'PA0999', 2, 2, 0, 6, 0 )
+          CALL message( 'lsm_rrd_local', 'PA0999', 2, 2, 0, 6, 0 )
        ENDIF
 
@@ -4310,5 +4324,5 @@
              message_string = 'For non-pavement surfaces the combination ' //  &
                               ' lai = 0.0 and c_veg = 1.0 is not allowed.'
-             CALL message( 'lsm_read_restart_data', 'PA0999', 2, 2, 0, 6, 0 )
+             CALL message( 'lsm_rrd_local', 'PA0999', 2, 2, 0, 6, 0 )
           ENDIF
        ENDDO
@@ -5015,6 +5029,4 @@
     USE indices
 
-    USE kinds
-
     IMPLICIT NONE
 
@@ -5349,6 +5361,4 @@
     USE indices
 
-    USE kinds
-
 
     IMPLICIT NONE
@@ -5608,6 +5618,4 @@
 
     USE indices
-
-    USE kinds
 
 
@@ -5688,12 +5696,9 @@
 ! Description:
 ! ------------
-!> Write restart data for land surface model
+!> Write restart data for land surface model. It is necessary to write 
+!> start_index and end_index several times.
 !------------------------------------------------------------------------------!
- SUBROUTINE lsm_write_restart_data
- 
-
-    USE control_parameters
+ SUBROUTINE lsm_wrd_local
         
-    USE kinds
 
     IMPLICIT NONE
@@ -5702,123 +5707,172 @@
     INTEGER(iwp)      ::  l      !< index variable for surface orientation
 
-    IF ( write_binary )  THEN
-
-
-       WRITE ( 14 ) 'ns_h_on_file_lsm    '
-       WRITE ( 14 ) surf_lsm_h%ns
-       WRITE ( 14 ) 'ns_v_on_file_lsm    '
-       WRITE ( 14 ) surf_lsm_v(0:3)%ns
-
-       IF ( ALLOCATED( c_liq_av ) )  THEN
-          WRITE ( 14 )  'c_liq_av            ';  WRITE ( 14 ) c_liq_av
-       ENDIF
-       IF ( ALLOCATED( c_soil_av ) )  THEN
-          WRITE ( 14 )  'c_soil_av           ';  WRITE ( 14 ) c_soil_av
-       ENDIF
-       IF ( ALLOCATED( c_veg_av ) )  THEN
-          WRITE ( 14 )  'c_veg_av            ';  WRITE ( 14 ) c_veg_av
-       ENDIF
-       IF ( ALLOCATED( lai_av ) )  THEN
-          WRITE ( 14 )  'lai_av              ';  WRITE ( 14 )  lai_av
-       ENDIF
-       IF ( ALLOCATED( m_liq_av ) )  THEN
-          WRITE ( 14 )  'm_liq_av            ';  WRITE ( 14 )  m_liq_av
-       ENDIF
-       IF ( ALLOCATED( m_soil_av ) )  THEN
-          WRITE ( 14 )  'm_soil_av           ';  WRITE ( 14 )  m_soil_av
-       ENDIF
-       IF ( ALLOCATED( qsws_liq_av ) )  THEN
-          WRITE ( 14 )  'qsws_liq_av         ';  WRITE ( 14 )  qsws_liq_av
-       ENDIF  
-       IF ( ALLOCATED( qsws_soil_av ) )  THEN
-          WRITE ( 14 )  'qsws_soil_av        ';  WRITE ( 14 )  qsws_soil_av
-       ENDIF 
-       IF ( ALLOCATED( qsws_veg_av ) )  THEN
-          WRITE ( 14 )  'qsws_veg_av         ';  WRITE ( 14 )  qsws_veg_av
-       ENDIF 
-       IF ( ALLOCATED( t_soil_av ) )  THEN
-          WRITE ( 14 )  't_soil_av           ';  WRITE ( 14 )  t_soil_av
-       ENDIF
+    CALL wrd_write_string( 'ns_h_on_file_lsm' )
+    WRITE ( 14 )  surf_lsm_h%ns
+
+    CALL wrd_write_string( 'ns_v_on_file_lsm' )
+    WRITE ( 14 )  surf_lsm_v(0:3)%ns
+
+
+    IF ( ALLOCATED( c_liq_av ) )  THEN
+       CALL wrd_write_string( 'c_liq_av' )
+       WRITE ( 14 )  c_liq_av
+    ENDIF
+
+    IF ( ALLOCATED( c_soil_av ) )  THEN
+       CALL wrd_write_string( 'c_soil_av' )
+       WRITE ( 14 )  c_soil_av
+    ENDIF
+
+    IF ( ALLOCATED( c_veg_av ) )  THEN
+       CALL wrd_write_string( 'c_veg_av' )
+       WRITE ( 14 )  c_veg_av
+    ENDIF
+
+    IF ( ALLOCATED( lai_av ) )  THEN
+       CALL wrd_write_string( 'lai_av' )
+       WRITE ( 14 )  lai_av
+    ENDIF
+
+    IF ( ALLOCATED( m_liq_av ) )  THEN
+       CALL wrd_write_string( 'm_liq_av' )
+       WRITE ( 14 )  m_liq_av
+    ENDIF
+
+    IF ( ALLOCATED( m_soil_av ) )  THEN
+       CALL wrd_write_string( 'm_soil_av' )
+       WRITE ( 14 )  m_soil_av
+    ENDIF
+
+    IF ( ALLOCATED( qsws_liq_av ) )  THEN
+       CALL wrd_write_string( 'qsws_liq_av' )
+       WRITE ( 14 )  qsws_liq_av
+    ENDIF
+
+    IF ( ALLOCATED( qsws_soil_av ) )  THEN
+       CALL wrd_write_string( 'qsws_soil_av' )
+       WRITE ( 14 )  qsws_soil_av
+    ENDIF
+
+    IF ( ALLOCATED( qsws_veg_av ) )  THEN
+       CALL wrd_write_string( 'qsws_veg_av' )
+       WRITE ( 14 )  qsws_veg_av
+    ENDIF
+
+    IF ( ALLOCATED( t_soil_av ) )  THEN
+       CALL wrd_write_string( 't_soil_av' )
+       WRITE ( 14 )  t_soil_av
+    ENDIF
+
+    CALL wrd_write_string( 'lsm_start_index_h' )
+    WRITE ( 14 )  surf_lsm_h%start_index
+
+    CALL wrd_write_string( 'lsm_end_index_h' )
+    WRITE ( 14 )  surf_lsm_h%end_index
+
+    CALL wrd_write_string( 't_soil_h' )
+    WRITE ( 14 )  t_soil_h%var_2d
        
-       WRITE ( 14 ) 'lsm_start_index_h   '
-       WRITE ( 14 ) surf_lsm_h%start_index
-       WRITE ( 14 ) 'lsm_end_index_h     '
-       WRITE ( 14 ) surf_lsm_h%end_index
-       WRITE ( 14 ) 't_soil_h            '
-       WRITE ( 14 ) t_soil_h%var_2d
+
        
-       DO  l = 0, 3
-          WRITE ( 14 ) 'lsm_start_index_v   '
-          WRITE ( 14 ) surf_lsm_v(l)%start_index
-          WRITE ( 14 ) 'lsm_end_index_v     '
-          WRITE ( 14 ) surf_lsm_v(l)%end_index
-          WRITE( dum, '(I1)')  l          
-          WRITE ( 14 ) 't_soil_v(' // dum // ')         ' 
-          WRITE ( 14 ) t_soil_v(l)%var_2d          
-       ENDDO
-
-       WRITE ( 14 ) 'lsm_start_index_h   '
-       WRITE ( 14 ) surf_lsm_h%start_index
-       WRITE ( 14 ) 'lsm_end_index_h     '
-       WRITE ( 14 ) surf_lsm_h%end_index
-       WRITE ( 14 ) 'm_soil_h            '
-       WRITE ( 14 ) m_soil_h%var_2d
+    DO  l = 0, 3
+
+       CALL wrd_write_string( 'lsm_start_index_v' )
+       WRITE ( 14 )  surf_lsm_v(l)%start_index
+
+       CALL wrd_write_string( 'lsm_end_index_v' )
+       WRITE ( 14 )  surf_lsm_v(l)%end_index
+
+       WRITE( dum, '(I1)')  l   
+
+       CALL wrd_write_string( 't_soil_v(' // dum // ')' )
+       WRITE ( 14 )  t_soil_v(l)%var_2d
+             
+    ENDDO
+
+    CALL wrd_write_string( 'lsm_start_index_h' )
+    WRITE ( 14 )  surf_lsm_h%start_index
+
+    CALL wrd_write_string( 'lsm_end_index_h' )
+    WRITE ( 14 )  surf_lsm_h%end_index
+
+    CALL wrd_write_string( 'm_soil_h' )
+    WRITE ( 14 )  m_soil_h%var_2d
+
+    DO  l = 0, 3
+
+       CALL wrd_write_string( 'lsm_start_index_v' )
+       WRITE ( 14 )  surf_lsm_v(l)%start_index
+
+       CALL wrd_write_string( 'lsm_end_index_v' )
+       WRITE ( 14 )  surf_lsm_v(l)%end_index
+
+       WRITE( dum, '(I1)')  l   
+
+       CALL wrd_write_string( 'm_soil_v(' // dum // ')' )
+       WRITE ( 14 )  m_soil_v(l)%var_2d 
+      
+    ENDDO
+
+    CALL wrd_write_string( 'lsm_start_index_h' )
+    WRITE ( 14 )  surf_lsm_h%start_index
+
+    CALL wrd_write_string( 'lsm_end_index_h' )
+    WRITE ( 14 )  surf_lsm_h%end_index
+
+    CALL wrd_write_string( 'm_liq_h' )
+    WRITE ( 14 )  m_liq_h%var_1d
        
-       DO  l = 0, 3
-          WRITE ( 14 ) 'lsm_start_index_v   '
-          WRITE ( 14 ) surf_lsm_v(l)%start_index
-          WRITE ( 14 ) 'lsm_end_index_v     '
-          WRITE ( 14 ) surf_lsm_v(l)%end_index
-          WRITE( dum, '(I1)')  l          
-          WRITE ( 14 ) 'm_soil_v(' // dum // ')         ' 
-          WRITE ( 14 ) m_soil_v(l)%var_2d          
-       ENDDO
-
-       WRITE ( 14 ) 'lsm_start_index_h   '
-       WRITE ( 14 ) surf_lsm_h%start_index
-       WRITE ( 14 ) 'lsm_end_index_h     '
-       WRITE ( 14 ) surf_lsm_h%end_index
-       WRITE ( 14 ) 'm_liq_h             '
-       WRITE ( 14 ) m_liq_h%var_1d
+    DO  l = 0, 3
+
+       CALL wrd_write_string( 'lsm_start_index_v' )
+       WRITE ( 14 )  surf_lsm_v(l)%start_index
+
+       CALL wrd_write_string( 'lsm_end_index_v' )
+       WRITE ( 14 )  surf_lsm_v(l)%end_index
+
+       WRITE( dum, '(I1)')  l   
+
+       CALL wrd_write_string( 'm_liq_v(' // dum // ')' )
+       WRITE ( 14 )  m_liq_v(l)%var_1d     
+                
+    ENDDO
+
+    CALL wrd_write_string( 'lsm_start_index_h' )
+    WRITE ( 14 )  surf_lsm_h%start_index
+
+    CALL wrd_write_string( 'lsm_end_index_h' )
+    WRITE ( 14 )  surf_lsm_h%end_index
+
+    CALL wrd_write_string( 't_surface_h' )
+    WRITE ( 14 )  t_surface_h%var_1d
+
+    DO  l = 0, 3
+
+       CALL wrd_write_string( 'lsm_start_index_v' )
+       WRITE ( 14 )  surf_lsm_v(l)%start_index
+
+       CALL wrd_write_string( 'lsm_end_index_v' )
+       WRITE ( 14 )  surf_lsm_v(l)%end_index
+
+       WRITE( dum, '(I1)')  l   
+
+       CALL wrd_write_string( 't_surface_v(' // dum // ')' )
+       WRITE ( 14 )  t_surface_v(l)%var_1d     
        
-       DO  l = 0, 3
-          WRITE ( 14 ) 'lsm_start_index_v   '
-          WRITE ( 14 ) surf_lsm_v(l)%start_index
-          WRITE ( 14 ) 'lsm_end_index_v     '
-          WRITE ( 14 ) surf_lsm_v(l)%end_index
-          WRITE( dum, '(I1)')  l          
-          WRITE ( 14 ) 'm_liq_v(' // dum // ')          ' 
-          WRITE ( 14 ) m_liq_v(l)%var_1d          
-       ENDDO
-
-       WRITE ( 14 ) 'lsm_start_index_h   '
-       WRITE ( 14 ) surf_lsm_h%start_index
-       WRITE ( 14 ) 'lsm_end_index_h     '
-       WRITE ( 14 ) surf_lsm_h%end_index
-       WRITE ( 14 ) 't_surface_h         '
-       WRITE ( 14 ) t_surface_h%var_1d
-       
-       DO  l = 0, 3
-          WRITE ( 14 ) 'lsm_start_index_v   '
-          WRITE ( 14 ) surf_lsm_v(l)%start_index
-          WRITE ( 14 ) 'lsm_end_index_v     '
-          WRITE ( 14 ) surf_lsm_v(l)%end_index
-          WRITE( dum, '(I1)')  l          
-          WRITE ( 14 ) 't_surface_v(' // dum // ')      ' 
-          WRITE ( 14 ) t_surface_v(l)%var_1d         
-       ENDDO
-
-
-       WRITE ( 14 )  '*** end lsm ***     '
-
-    ENDIF
-
- END SUBROUTINE lsm_write_restart_data
-
-
-SUBROUTINE lsm_read_restart_data( i, nxlfa, nxl_on_file, nxrfa, nxr_on_file,   &
-                                     nynfa, nyn_on_file, nysfa, nys_on_file,   &
-                                     offset_xa, offset_ya, overlap_count,      &
-                                     tmp_2d )
+    ENDDO
+
+
+ END SUBROUTINE lsm_wrd_local
+
+
+!------------------------------------------------------------------------------!
+!
+! Description:
+! ------------
+!> Soubroutine reads lsm data from restart file(s)
+!------------------------------------------------------------------------------!
+SUBROUTINE lsm_rrd_local( i, k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,           &
+                          nxr_on_file, nynf, nync, nyn_on_file, nysf, nysc,    &
+                          nys_on_file, tmp_2d, found )
  
 
@@ -5827,11 +5881,8 @@
     USE indices
     
-    USE kinds
-    
     USE pegrid
 
+
     IMPLICIT NONE
-
-    CHARACTER (LEN=20) :: field_char   !< 
 
     INTEGER(iwp) ::  i                 !< 
